import { j as e } from "../../../node_modules/react/jsx-runtime.mjs";
import { useContext as ze, useState as q, useMemo as a, useEffect as Te, useRef as T, useCallback as ke } from "react";
import { isMobile as I } from "../../../node_modules/react-device-detect/dist/lib.mjs";
import { theme as Me, Table as k, Skeleton as Le } from "antd";
import He from "../../BitzDrawer/index.mjs";
import ue from "../../BitzLoadMore/index.mjs";
import Ee from "../../BitzPagination/index.mjs";
import Oe from "../../BitzNoData/index.mjs";
import Pe, { TableContext as Ve } from "../Store/index.mjs";
import _e from "../TableSkeleton/index.mjs";
import { columnSort as De, genColumnKey as J } from "../Store/utils/index.mjs";
import M from "../../../node_modules/ahooks/es/useSize/index.mjs";
import "./index.less.mjs";
import Fe from "../../../node_modules/lodash-es/at.mjs";
const Ke = ({
  tableItemEmit: d = () => {
  },
  showPagination: Q = !0,
  fillEvenRow: L = !0,
  evenRowBgColor: H = "#f9f9f9",
  outerHeight: x,
  outerMaxHeightRate: u = 0.4,
  heightRate: E = 0.6,
  dataSource: n = [],
  total: w = 0,
  columns: f,
  loading: g = !1,
  skeletonNum: W = 2,
  skeletonRender: O,
  skeletonRowNum: Y = 4,
  skeletonRowsWidth: Z = ["35%", "100%", "100%", "60%"],
  tableOperationEmit: R = () => {
  },
  mobileLoadEmit: S = () => {
  },
  mobileRefreshEmit: ee = () => {
  },
  operations: ne = [],
  enableControlPage: se,
  pagination: le,
  paginationEmit: ie = () => {
  },
  mobilePageHeight: re = 500,
  mobileCancelText: te = "取消",
  noDataTitle: oe,
  noDataImg: he,
  color: ae,
  // eslint-disable-next-line @typescript-eslint/no-unused-vars
  size: P,
  showTableTool: xe = !0,
  tableAction: fe,
  tableToolbar: be,
  selectionBar: ce,
  scroll: t,
  resetPage: ge,
  ...b
}) => {
  Me.useToken();
  const h = ze(Ve), [me, y] = q(!1), [pe, je] = q({}), de = a(() => (n == null ? void 0 : n.length) == w && (n == null ? void 0 : n.length) > 0, [n, w]), Ne = (s) => {
    y(!0), je(s), d(s);
  }, V = () => {
    y(!1);
  }, ve = (s) => {
    y(!1), R(s.type, pe);
  }, m = a(() => {
    const s = (r) => r.map((i) => {
      const p = J(
        (i == null ? void 0 : i.key) || (i == null ? void 0 : i.dataIndex),
        i.index
      ), j = h.columnsMap[p];
      return j && j.show === !1 ? !1 : i.children ? {
        ...i,
        children: s(i.children)
      } : i;
    }).filter(Boolean), l = s(f);
    return [
      k.SELECTION_COLUMN,
      k.EXPAND_COLUMN,
      ...l.sort(De(h.columnsMap))
    ];
  }, [h.columnsMap, f]);
  Te(() => {
    if (f && f.length > 0) {
      const s = f.map(
        (l) => (
          // @ts-ignore
          J((l == null ? void 0 : l.key) ?? (l == null ? void 0 : l.dataIndex), l == null ? void 0 : l.dataIndex)
        )
      );
      h.setSortKeyColumns(s);
    }
  }, [f]);
  const N = T(null), C = M(N), _ = T(null), o = M(_), { tableBlockHeight: v, y: B, paginationHeight: D, containerGap: F } = a(() => {
    if (typeof x > "u")
      return {};
    const s = window.innerHeight, l = x > s * u;
    let r = s - x;
    l && (r = s * E);
    let i = 40, p = 20, j = 40;
    if (N.current) {
      const z = window.getComputedStyle(N.current);
      i = parseInt(
        z.getPropertyValue("--cell-block") || "40"
      );
      const Be = parseInt(
        z.getPropertyValue("--container-gap") || "20"
      );
      p = n.length ? Be : 0, j = parseInt(
        z.getPropertyValue("--toolbar-height") || "40"
      );
    }
    const ye = o == null ? void 0 : o.height, Ce = r - j - i - p - ((o == null ? void 0 : o.height) || 0);
    return { tableBlockHeight: r, y: Ce, paginationHeight: ye, containerGap: p };
  }, [
    x,
    u,
    E,
    n,
    o == null ? void 0 : o.height,
    C == null ? void 0 : C.height
  ]), K = T(null), c = M(K), G = a(() => {
    const s = ((c == null ? void 0 : c.height) || 0) + (F || 0) + (D || 0);
    return (v || 0) > s;
  }, [
    c == null ? void 0 : c.height,
    v,
    D,
    F
  ]), we = a(() => G ? window.innerHeight - (x || 0) : v, [x, G, v]), $ = a(() => t != null && t.x ? { x: t.x, y: t.y || B } : t != null && t.y ? n != null && n.length ? { x: 1e3, y: t.y } : { x: 1e3 } : n != null && n.length ? { x: 1e3, y: B } : { x: 1e3 }, [n, t, B]), A = a(() => `${P ?? (h == null ? void 0 : h.tableSize) ?? "lg"}BitzTable`, [P, h.tableSize]), U = a(() => ({
    "--evenRow-BgColor": H
    // '--tableBody-bootomBorderColor': token.Table?.borderColor || '#f0f0f0',
  }), [
    H
    /** token.Table?.borderColor */
  ]), X = ke(
    (s, l) => L ? l % 2 === 0 ? "oddRow" : "evenRow" : "",
    [L]
  );
  return /* @__PURE__ */ e.jsxs("div", { className: "bitzTableBlock", children: [
    !I && /* @__PURE__ */ e.jsxs(
      "div",
      {
        ref: N,
        className: `bitzTableContainer ${A}`,
        style: { height: we },
        children: [
          /* @__PURE__ */ e.jsxs("div", { className: "bitzTableContainerBody", ref: K, children: [
            xe && /* @__PURE__ */ e.jsxs("div", { className: "bitzTableToolbarBlock", children: [
              fe || /* @__PURE__ */ e.jsx("div", {}),
              be,
              (b == null ? void 0 : b.rowSelection) && /* @__PURE__ */ e.jsx(e.Fragment, { children: ce })
            ] }),
            g ? /* @__PURE__ */ e.jsx(
              _e,
              {
                columns: m,
                dataLength: n == null ? void 0 : n.length,
                scroll: $,
                rowSelection: b.rowSelection,
                expandable: b.expandable,
                className: A,
                style: U,
                rowClassName: X
              }
            ) : /* @__PURE__ */ e.jsx(
              k,
              {
                columns: m,
                dataSource: n,
                loading: g,
                pagination: !1,
                scroll: $,
                ...b,
                style: U,
                rowClassName: X
              }
            )
          ] }),
          Q && /* @__PURE__ */ e.jsx(
            Ee,
            {
              ref: _,
              enableControl: se,
              pagination: le,
              total: w,
              dataSource: n,
              resetPage: ge,
              paginationEmit: ie
            }
          )
        ]
      }
    ),
    I && /* @__PURE__ */ e.jsxs(e.Fragment, { children: [
      (g || (n == null ? void 0 : n.length) > 0) && /* @__PURE__ */ e.jsx(
        ue,
        {
          color: ae,
          height: re,
          showNoMore: de,
          refreshEmit: ee,
          loadEmit: S,
          extra: /* @__PURE__ */ e.jsxs("div", { className: "mobileTable", children: [
            n == null ? void 0 : n.map((s, l) => /* @__PURE__ */ e.jsxs("div", { children: [
              /* @__PURE__ */ e.jsx("div", { className: "rowBox", children: m == null ? void 0 : m.map((r, i) => /* @__PURE__ */ e.jsx("div", { children: !(r != null && r.mobileHide) && /* @__PURE__ */ e.jsxs(
                "div",
                {
                  className: "row",
                  onClick: () => {
                    Ne(s);
                  },
                  children: [
                    /* @__PURE__ */ e.jsxs("div", { className: "label", children: [
                      r.title,
                      "："
                    ] }),
                    /* @__PURE__ */ e.jsx("div", { className: "value", children: r.render(
                      Fe(s, r == null ? void 0 : r.dataIndex),
                      s,
                      l
                    ) })
                  ]
                }
              ) }, i)) }),
              /* @__PURE__ */ e.jsx("div", { className: "rowBoxLine" })
            ] }, l)),
            g && Array.from({ length: W }).map((s, l) => /* @__PURE__ */ e.jsxs("div", { children: [
              /* @__PURE__ */ e.jsx("div", { className: "rowBox", children: O ? O() : /* @__PURE__ */ e.jsx(
                Le,
                {
                  title: !1,
                  paragraph: {
                    rows: Y,
                    width: Z
                  },
                  active: !0
                }
              ) }),
              /* @__PURE__ */ e.jsx("div", { className: "rowBoxLine" })
            ] }, l)),
            /* @__PURE__ */ e.jsx(
              He,
              {
                className: "tableMobileDrawer",
                open: me,
                placement: "bottom",
                height: "auto",
                closable: !1,
                onClose: V,
                children: /* @__PURE__ */ e.jsxs("div", { className: "drawerBox", children: [
                  /* @__PURE__ */ e.jsx("div", { className: "boxBody", children: ne.map((s, l) => /* @__PURE__ */ e.jsx(
                    "div",
                    {
                      className: "operaList",
                      onClick: () => {
                        ve(s);
                      },
                      children: s.label
                    },
                    l
                  )) }),
                  /* @__PURE__ */ e.jsx("div", { className: "boxLine" }),
                  /* @__PURE__ */ e.jsx("div", { className: "boxFooter", onClick: V, children: te })
                ] })
              }
            )
          ] })
        }
      ),
      !g && /* @__PURE__ */ e.jsx(Oe, { data: n, title: oe, img: he })
    ] })
  ] });
}, en = (d) => (
  // @ts-ignore
  /* @__PURE__ */ e.jsx(Pe, { initValue: d, children: /* @__PURE__ */ e.jsx(Ke, { ...d }) })
);
export {
  en as default
};
